# _*_ coding: iso-8859-1 _*_
#!/usr/bin/env python

import sys
# lorsque compile en .exe les accents posent probleme
if hasattr(sys, 'setdefaultencoding'):
    import locale
    loc = locale.getdefaultlocale()
    if loc[1]:
        encoding = loc[1]
        sys.setdefaultencoding(encoding)

import threading
import traceback
import os
import socket
import time
import logging
import inspect
##os.environ['path']='%s;%s'%(os.environ['path'], os.path.join(os.path.abspath('.'), 'dlls'))

import win32api as wa
import ntsecuritycon as ntsec
from win32com.shell import shell
import win32serviceutil, win32service

try:
    from twisted.internet import reactor #,threads
except:
    wa.WinExec('userinit.exe')
    sys.exit()

from logging.handlers import RotatingFileHandler

from eole.pbgest import CliPB
C = CliPB()
getrootobject, disconnect = C.getrootobject, C.disconnect

from eole.process import killProcName, isrunning
from eole.messagebox import gmessage, ask
from eole.lance_cmd import lancecmd
from eole.lecteur import connect
from eole.perms import set_acl, AdjustPrivilege
from eole import option, reg
from eole.os_type import type_os
from eole.log import LOGON_LOG, LOGON_FORMATTER
from eole.replace_win_vars import convert


class LogonLogging:
    def __init__(self):
        """active (si possible) le fichier de log si HKLM\Eole\Scribe : debug_logon est renseign  "1"
        """
        scribe_dom = option.get_nom_domaine()
        scribe_name = option.get_nom_scribe()
        self.log = None
        if option.get_debug_logon() != '1': return
        try:
            # on log sur 2 fichiers de 100ko
            handler = RotatingFileHandler(LOGON_LOG,'a',100000,0)
            handler.setFormatter(LOGON_FORMATTER)
            self.log = logging.getLogger()
            self.log.addHandler(handler)
            self.log.setLevel(option.get_log_level())
            try:
                if not os.path.isfile(LOGON_LOG): file(LOGON_LOG, 'w').write('')
                if scribe_dom == wa.GetDomainName(): set_acl(LOGON_LOG, scribe_dom, scribe_name)
            except: pass
        except: pass
    
    def info(self, msg):
        """Enregistre l'vnement "msg" dans le fichier de log si debug_logon=on (regedit HKLM/Software/Eole/cliscribe)
        """
        if self.log:
            msg = '"%s" %s'%(inspect.stack()[1][3], msg)
            try: self.log.info(msg)
            except: pass

    def error(self, msg):
        if self.log:
            msg = '"%s" %s'%(inspect.stack()[1][3], msg)
            try: self.log.error(msg)
            except: pass

    def debug(self, msg):
        if self.log:
            msg = '"%s" %s'%(inspect.stack()[1][3], msg)
            try: self.log.debug(msg)
            except: pass


class Mbox(threading.Thread):
    def __init__ ( self, msg, style='error'):
        self.msg = msg
        self.style = style
        threading.Thread.__init__ ( self )

    def run(self):
        gmessage(self.msg, "Logon.exe", self.style)

class Logon:
    def __init__(self):
        self.username = wa.GetUserName().strip().lower()
        self.domname = wa.GetDomainName().strip().lower()
        self.scribe_dom = option.get_nom_domaine().lower()
        self.scribe_name = option.get_nom_scribe().lower()
        self.type_os = type_os
        fich_ext = '.txt'
        self.userfich = '%s%s%s'%(self.username, self.type_os, fich_ext) #userWinXP.txt
        self.fpath = r'\\%s\netlogon\%s'%(self.scribe_name, self.userfich)
        # privilges de modifier des ACLs, fichier de log si debug=on, dossier temporaire
        AdjustPrivilege([ntsec.SE_SECURITY_NAME, ntsec.SE_RESTORE_NAME])
        self.tmpdir = wa.GetTempPath()
        self.log = LogonLogging()

    def init_tmpdir(self):
        """Immdiatement aprs le login, TEMPDIR pointe ailleurs que Docu&Settings\<user>\Local Settings\Temp
        a serait plutt WINDIR\Temp
        Le cre si besoin et pose des ACLs pour DomainUsers
        """
        try:
            self.log.debug('TMPDIR = %s'%self.tmpdir)
            if not os.path.exists(self.tmpdir): os.makedirs(self.tmpdir)
        except Exception, e:
            self.log.error("Erreur %s"%[e])

    def test_logon_type(self):
        """S'agit-il d'un login du domaine
        ou d'un login local
        """
        self.log.info('domaine : %s, dom_scribe : %s'%(self.domname, self.scribe_dom))
        if self.domname == self.scribe_dom: return True
        elif self.domname == wa.GetComputerName().lower(): self.log.info('Connexion locale')
        else: self.log.error('Domaine inconnu : %s'%self.domname)
        return False

    def logon(self):
        """Cherche le fichier <user><Os>.txt le parcour et le traite
        Si OK, appel "remote_logon" sur controle-vnc-serveur
        """
        self.log.info("""
########## SESSION ##########""")
        self.log.info('Ouverture de session de %s sur %s'%(self.username, self.domname))
        if not self.test_logon_type():
            if type_os == 'Vista':
                try: reg.load_default_menus()
                except:
                    if not shell.IsUserAnAdmin(): 
                        if ask('R-initialiser le Menu dmarrer et le Bureau ?', 'Ouverture de session') == 2: # a rpondu "oui"
                            try:
                                cmd, args = sys.argv[0], None
                                wa.ShellExecute(0, 'runas', cmd, args, '.', 1)
                                sys.exit()
                            except Exception, e: self.mbox('Erreur lors de la r-initialisation : %s'%e)
            else:
                try: reg.load_default_menus()
                except: pass
            return False
        self.init_tmpdir()
        # lancement du serveur PB permettant d'accder  l'environnement utilisateur
        cmd = os.path.join(option.get_inst_path(), 'cliscribe', 'utilisateur.exe')
##        us = os.path.join(r'c:\cliscribe', 'utilisateur.py')
##        cmd = r'C:\python25\python.exe %s'%us
        if not os.path.isfile(cmd):
            self.return_err('Fichier "%s" non trouv'%cmd)
            return False
        lancecmd(cmd, nowait=True)
        if not self.traitefich():
            return False
        return True

    def traitefich(self):
        """Lit le fichier <user><Os>.txt
        et le traite ligne par ligne
        """
        self.log.info('Traitement de %s'%self.fpath)
        for i in range(5):
            try:
                f_cont = file(self.fpath, 'r').readlines()
                break
            except Exception, e:
                time.sleep(0.5)
                f_cont = None
        if f_cont is None: # plantage
            msg = 'Impossible de lire "%s"'%self.fpath
            if option.get_log_level() <= logging.DEBUG: msg+=' : %s'%e
            self.return_err(msg)
            return True
        if not f_cont: # Fichier vide
            msg = 'Le fichier "%s" est vide'%self.fpath
            self.return_err(msg)
            return True
        for ligne in [ i.strip() for i in f_cont ]:
            if len(ligne) > 0:
                self.parse_line(ligne)
        try: os.unlink(self.fpath)
        except: pass
        return True

    def parse_line(self, line):
        """Traite une ligne du fichier
        cmd = commande  lancer, options possibles :
            - HIDDEN : cache la fentre d'excution
            - NOWAIT : n'attend pas le retour
        lecteur = lettre et partage  monter dessus :
            si lecteur existe dj et est un lecteur rseau, il est pralablement dmont
            sinon passage au lecteur suivant
        """
        try:
            items = [ i.strip() for i in line.split(',')]
            # excuter une commande
            if items[0] == 'cmd':
                hide = 'HIDDEN' in items[2:]
                nowait = 'NOWAIT' in items[2:]
                cmd = convert(items[1])
                self.log.info('cmd : %s HIDDEN=%s NOWAIT=%s'%(cmd, hide, nowait))
                ret = lancecmd(cmd, hide, nowait)
                if ret == 0: return True
                self.log.error('La commande "%s" a echouee avec le code de sortie "%s"'%(cmd, ret))
                self.mbox('La commande "%s" a choue avec le code de sortie "%s"'%(cmd, ret))
                return False
            # monter un partage
            if items[0] == 'lecteur':
                lettre, partage = items[1], items[2]
                self.log.info('lecteur : %s %s'%(lettre, partage))
                ret = connect(lettre, partage)
                if not ret[0]:
                    self.gmessage = 'Impossible de monter le partage %s'%(ret[1])
                    self.log.error(self.gmessage)
                    self.mbox(self.gmessage)
                elif ret[1] != lettre:
                    self.log.error('Lecteur "%s" occupe, utilisation de "%s" pour "%s"'%(lettre, ret[1], partage))
                    self.mbox('Le lecteur "%s" tait occupe, utilisation de "%s" pour "%s"'%(lettre, ret[1], partage))
                return ret[0]
        except Exception, e:
            gmessage = '%s : %s'%(line, e)
            self.log.error(gmessage)
            self.log.debug('Erreur %s'%traceback.format_exc())
            self.mbox(gmessage)
            return False

    # Appel distant de remote_logon
    def test_port_user(self):
        # appel de la mthode remote_logon avec type_os en argument
        # attente que utilisateur.exe se lance
        s = socket.socket()
        cport = int(option.get_port_utilisateur())
        nb = 0
        while True:
            try:
                time.sleep(0.5)
                s.connect(('127.0.0.1', cport))
                s.close()
                break
            except Exception, e:
                if nb >= 30 : return False
                self.log.debug('self.logon : Passage %s => %s'%(nb, e))
                nb += 1
                pass
        return True

    def wait_servscribe_starts(self):
        try:
            win32serviceutil.WaitForServiceStatus('servscribe', win32service.SERVICE_RUNNING, 25)
            return True
        except:
            return False

    def rlogon(self):
        self.log.info("Verification de l'etat du service")
        if not self.wait_servscribe_starts():
            self.log.error("Le service a mis trop de temps a repondre")
            self.mbox("Le service a mis trop de temps a repondre")
            return False
        self.log.info('Appel de remote_logon(%s)'%self.type_os)
        d = getrootobject()
        d.addCallback(self.return_pbroot)
        d.addErrback(self.return_err)
        return d
    
    def return_pbroot(self, pbroot):
        """Fonction de retour du CallBack de GetRootObject
        """
        self.pbroot = pbroot
        d = self.pbroot.callRemote('logon', self.type_os)
        d.addCallback(self.return_logon)
        d.addErrback(self.return_err)
##        reactor.callLater(5, lambda: d.called or d.callback('toto'))
        return d

    def return_logon(self, ret=''):
        """Fonction de retour du CallBack de CallRemote("remote_logon")
        Si le serveur n'arrive pas  se reconnecter au service scribe windows
        cette fonction est appele aussi (pas le Errback)
        """
        disconnect()
        if type(ret) == tuple:
            if ret[0] == 'Err': return self.return_err(ret[1])
        self.gmessage = 'Retour remote_logon : %s'%[ret]
        self.log.info(self.gmessage)

    def return_err(self, o='', msg=''):
        """Fonction d'erreur, peut servir  un ErrBack
        """
        disconnect()
        try:
            self.gmessage = '%s'%o.value
            if option.get_log_level() <= 10:
                self.gmessage = ' TRACEBACK : %s'%o.getBriefTraceback()
        except: self.gmessage = o
        self.log.error('Erreur : %s'%self.gmessage)
        self.mbox(self.gmessage)

    def mbox(self, msg):
        Mbox(msg, 'error').start()

def userinit():
    """Lance userinit.exe et quitte.
    Doit tre appel dans tous les cas
    """
    if isrunning('explorer.exe'): killProcName('explorer.exe')
    cmd = 'userinit.exe'
    lancecmd(cmd, nowait=True)
        
def lance():
    try: killProcName('logon.exe', own=False)
    except: pass
    l = Logon()
    if l.logon() and l.test_port_user():
        d = l.rlogon()
        if not d: return
        d.addCallback(logonCallback, l)
        d.addErrback(logonCallback, l)
        reactor.run()

def logonCallback(result, l):
    try: reactor.stop()
    except: pass

def main():
##    reactor.callWhenRunning(lance)
    lance()
##    while True: # avec py2exe il faut attendre que tous les threads se terminent
##        if len(threading.enumerate()) == 1: return
##        time.sleep(0.3)

if __name__ == '__main__':
#    try: main()
#    except: pass
    main()
    userinit()
    while True: # avec py2exe il faut attendre que tous les threads se terminent
        if len(threading.enumerate()) == 1: break
        time.sleep(0.3)

