# _*_ coding: iso-8859-1 _*_
#########################################
# Gnration du service client SCRIBE   #
# pour la gestion du poste              #
# licence GPL Eole                      #
#########################################


import win32serviceutil
import win32service
import win32event
import win32evtlogutil
import servicemanager
import time
import sys

from logging.handlers import RotatingFileHandler
import logging

from eole.log import SERVICE_LOG, FORMATTER
from eole import option

# lorsque compile en .exe les accents posent probleme
if hasattr(sys, 'setdefaultencoding'):
    import locale
    loc = locale.getdefaultlocale()
    if loc[1]:
        encoding = loc[1]
        sys.setdefaultencoding(encoding)

# dfinition du service
nom="servscribe"
libelle="Service Scribe"


class MyService(win32serviceutil.ServiceFramework):
    """
       Dfinition du service Windows
    """
    _svc_name_ = nom
    _svc_display_name_ = libelle
    _svc_deps_ = ["EventLog"]
    
    def __init__(self, args):
        win32serviceutil.ServiceFramework.__init__(self, args)
        self.hWaitStop = win32event.CreateEvent(None, 0, 0, None)

    def SvcDoRun(self):
        win32evtlogutil.AddSourceToRegistry(self._svc_name_, servicemanager.__file__)
        # Write a 'started' event to the event log...
        win32evtlogutil.ReportEvent(self._svc_name_,
                                    servicemanager.PYS_SERVICE_STARTED,
                                    0, # category
                                    servicemanager.EVENTLOG_INFORMATION_TYPE,
                                    (self._svc_name_, ''))
        # dmarrage du serveur PB
        self.gestServ = lance()
        self.gestServ.servstart()
        # and write a 'stopped' event to the event log.
        win32evtlogutil.ReportEvent(self._svc_name_,
                                    servicemanager.PYS_SERVICE_STOPPED,
                                    0, # category
                                    servicemanager.EVENTLOG_INFORMATION_TYPE,
                                    (self._svc_name_, ''))
    
    def SvcStop(self):
        self.ReportServiceStatus(win32service.SERVICE_STOP_PENDING)
        self.gestServ.servstop()
        win32event.SetEvent(self.hWaitStop)

    #c'est un appel diffrent quand on reboot/halt
    #que pour 'net stop servscribe'
    SvcShutdown = SvcStop


def lance(installSignalHandlers=0):
    # on log sur 2 fichiers de 100ko
    handler = RotatingFileHandler(SERVICE_LOG,'a',100000,2)
    handler.setFormatter(FORMATTER)
    log = logging.getLogger()
    log.addHandler(handler)
    log.setLevel(option.get_log_level())

    # Tant que ipfw n'est pas lanc, l'import plante
##    from servscribe_class import gestServ
    while True:
        try:
            from servscribe_class import gestServ
            break
        except:
            time.sleep(0.5)
            continue
    g = gestServ(installSignalHandlers)
    return g
    
if __name__ == '__main__':
    # Note that this code will not be run in the 'frozen' exe-file!!!
    if '-test' in sys.argv[1:]:
        g = lance(installSignalHandlers=1)
        g.servstart()
    else:
        win32serviceutil.HandleCommandLine(MyService)
