# _*_ coding: iso-8859-1 _*_
#
# gestion du fichier %WINDIR%\system32\drivers\etc\hosts
# et %WINDIR%\system32\drivers\etc\lmhosts.sam
# pour accélérer la résolution du domaine

import os, sys
from eole import option
##import logging

HOSTS = os.path.join(os.environ['WINDIR'], r'system32\drivers\etc\hosts')
LMHOSTS = os.path.join(os.environ['WINDIR'], r'system32\drivers\etc\lmhosts.sam')
SCRIBE = option.get_nom_scribe().upper()
DOMAINE = option.get_nom_domaine().upper()
IP = option.get_ip_scribe()

def addtohosts():
    c = file(HOSTS).readlines()
    r = []
    found = False
    rewrite = False
    # parcours du fichier "hosts", suppression (non copie) des mauvaises lignes
    # et ajout de la ligne "1.1.1.1    scribe" si non trouve
    for i in c:
        if i.strip().startswith('#') or not i.strip():
            if not i.endswith('\n'): i = '%s\n'%i #retour chariot fin de fichier
            r.append(i) # on conserve les commentaires et les lignes vides
            continue
        try:
            ip, host = i.strip().split()[:2]
        except:
            continue
        host = host.upper().split('.')[0] #au cas o scribe.domaine.lan
        if host == SCRIBE: # bon nom
            if ip != IP: # mauvaise IP
                rewrite = True
                continue
            else:
                found = True # bonne IP, la ligne est dj prsente
        if ip == IP and host != SCRIBE: # bonne IP, mauvais nom
            rewrite = True
            continue
        if host == DOMAINE: # le domaine pas dans "hosts"
            rewrite = True
            continue
            #c.append('%s    %s'%(IP, DOMAINE))
        r.append(i) # la ligne est bonne, elle est conserve
    
    if not found:
        rewrite = True
        r.append('%s    %s\n'%(IP, SCRIBE))

    if rewrite:
##        logging.info('reecriture de "%s"'%HOSTS)
        print 'reecriture de "%s"'%HOSTS
        file(HOSTS, 'w').writelines(r)

def delfromhosts():
    c = file(HOSTS).readlines()
    r = []
    rewrite = False
    # parcours du fichier "hosts", suppression (non copie)
    # de la ligne "1.1.1.1    scribe"
    for i in c:
        if i.strip().startswith('#') or not i.strip():
            r.append(i) # on conserve les commentaires et les lignes vides
            continue
        try:
            ip, host = i.strip().split()[:2]
        except:
            continue
        host = host.upper().split('.')[0] #au cas o scribe.domaine.lan
        if host == SCRIBE: # bon nom
            if ip == IP: # mauvaise IP
                rewrite = True
                continue
        r.append(i) # la ligne est bonne, elle est conserve

    if rewrite:
##        logging.info('reecriture de "%s"'%HOSTS)
        print 'reecriture de "%s"'%HOSTS
        file(HOSTS, 'w').writelines(r)


def addtolmhosts():
    c = file(LMHOSTS).readlines()
    r = []
    found = False
    domfound = False
    rewrite = False
    scribe_line = '%s    %s       #PRE #DOM:%s\n'%(IP, SCRIBE, DOMAINE)
    d = '"%s%s\\0x1b"'%(DOMAINE, ' '*(15 - len(DOMAINE)))
    dom_line = '%s    %s   #PRE\n'%(IP, d)
    # parcours du fichier "hosts", suppression (non copie) des mauvaises lignes
    # et ajout de la ligne "1.1.1.1    scribe" si non trouve
    for i in c:
        if i.strip().startswith('#') or not i.strip():
            if not i.endswith('\n'): i = '%s\n'%i #retour chariot fin de fichier
            r.append(i) # on conserve les commentaires et les lignes vides
            continue
        try:
            ip, host = i.strip().split()[:2]
            host = host.upper()
            if host.startswith('"'): host = host[1:]
        except:
            continue
        if host == SCRIBE: # bon nom
            if i.strip() == scribe_line.strip(): # bonne ligne
                found = True
            else:
                rewrite = True
                continue
        if host == DOMAINE:
            if i.strip() == dom_line.strip():
                domfound = True
            else:
                rewrite = True
                continue
            #c.append('%s    %s'%(IP, DOMAINE))
        r.append(i) # la ligne est bonne, elle est conserve
    
    if not found:
        rewrite = True
        r.append(scribe_line)

    if not domfound:
        rewrite = True
        r.append(dom_line)

    if rewrite:
##        logging.info('reecriture de "%s"'%LMHOSTS)
        print 'reecriture de "%s"'%LMHOSTS
        file(LMHOSTS, 'w').writelines(r)

def delfromlmhosts():
    c = file(LMHOSTS).readlines()
    r = []
    rewrite = False
    # parcours du fichier "hosts"
    # suppression (non copie) des la lignes '1.1.1.1    SCRIBE    #PRE #DOM:DOMAINE'
    # et '1.1.1.1    "DOMAINE        \0x1b"    #PRE'
    for i in c:
        if i.strip().startswith('#') or not i.strip():
            r.append(i) # on conserve les commentaires et les lignes vides
            continue
        try:
            ip, host = i.strip().split()[:2]
            if host.startswith('"'): host = host[1:]
        except:
            continue
        if host == SCRIBE:
            rewrite = True
            continue
        if host == DOMAINE:
            rewrite = True
            continue
            #c.append('%s    %s'%(IP, DOMAINE))
        r.append(i) # la ligne est bonne, elle est conserve
    
    if rewrite:
##        logging.info('reecriture de "%s"'%LMHOSTS)
        print 'reecriture de "%s"'%LMHOSTS
        file(LMHOSTS, 'w').writelines(r)

def main():
    msg = """Utilisation :
%s --addhost
%s --delhost
"""%(sys.argv[0], sys.argv[0])
    if len(sys.argv) == 1:
        sys.exit(msg)
    if sys.argv[1] == '--addhost':
        addtolmhosts()
        addtohosts()
    elif sys.argv[1] == '--delhost':
        delfromlmhosts()
        delfromhosts()
    else:
        sys.exit("""Argument inconnu "%s"
%s"""%(sys.argv[1], msg))

if __name__ == '__main__':
    main()